/**
 * This file is part of Graylog.
 *
 * Graylog is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Graylog is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Graylog.  If not, see <http://www.gnu.org/licenses/>.
 */
package org.graylog2.rest.models.system.inputs.responses;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.google.auto.value.AutoValue;
import org.graylog2.rest.models.system.responses.IOStateSummary;
import org.joda.time.DateTime;

import javax.annotation.Nullable;

@JsonAutoDetect
@AutoValue
public abstract class InputStateSummary extends IOStateSummary {
    @JsonProperty
    public abstract InputSummary messageInput();

    @JsonCreator
    public static InputStateSummary create(@JsonProperty("id") String id,
                                           @JsonProperty("state") String state,
                                           @JsonProperty("started_at") DateTime startedAt,
                                           @JsonProperty("detailed_message") @Nullable String detailedMessage,
                                           @JsonProperty("message_input") InputSummary messageInput) {
        return new AutoValue_InputStateSummary(id, state, startedAt, detailedMessage, messageInput);
    }
}
